#!/usr/bin/perl -w

use strict;



                         # NeuVid  PROGRAM #
##########################################################################
#### Aquest programa ens permet fer prediccions de gens a partir d'un ####
#### conjunt d'exons  donat. Cada  cop que  correm  el programa podem ####
#### predir un nic gen. Es el propi usuari el que determina les res- ####
#### triccions a tenir en compte a l'hora de fer l'ensamblatge dels   ####
#### exons, creant un fitxer que les contingui i que es llegir amb   ####
#### el filehandle PARAMETRES.                                        ####
##########################################################################


######################## 1:ENTRADA DE LES DADES ##########################

## Creem el filehandle TOTSEXONS per poder llegir el fitxer GFF que     ##
## conte el conjunt d'exons.                                            ##


my $nomfitxer;

$nomfitxer=$ARGV[0];

open(TOTSEXONS,"$nomfitxer") || die "el fitxer no es pot obrir";


my @dades;  #matriu que cont les dades inicials (s necessria per ordenar-la 
            # per ordre d'acceptor),posteriorment passarem a vectors 

my @acc;    #vector que cont la posici acceptor de tots els exons
my @don;    #vector que cont la posici donnor de tots els exons
my @pun;    #vector que cont l'score de cada un dels exons
my @strand; #vector que cont la cadena de cada ex
my @frame;  #vector que cont el frame de tots els exons
my @rem;    #vector que cont el remainder de tots els exons
my @tipus;  #tipus d'ex: first/internal/terminal
my @codi;   #referencia de GenBank 
my @ppred;  #programa de predicci dels exons utilitzat

my $i=0;
my $j;

## llegim el fitxer gff donat de forma que cada parmetre sigui una columna  ##
## de la matriu dades.Aquesta matriu la ordenarem per ordre d'acceptor       ##
## creixent.Noms tenim en compte exons d'estrand (+)                        ##
## Posteriorment ho passarem als vectors  que utilitzarem durant el programa ##

while (<TOTSEXONS>) {

    if (m/(\w+)\s+([\w\.]+)\s+(\w+)\s+(\d+)\s+(\d+)\s+([\d\.\-]+)\s+([\+\-])\s+([012])/) {
     
	if ($7 eq '+') {

      $dades[$i][0]=$1;   #codi
      $dades[$i][1]=$2;   #programa prediccio de gens
      $dades[$i][2]=$3;   #tipus d'exo
      $dades[$i][3]=$4;   #acceptor
      $dades[$i][4]=$5;   #donor
      $dades[$i][5]=$6;   #score
      $dades[$i][6]=$7;   #strand 
      $dades[$i][7]=$8;   #frame

      $dades[$i][8]= (3-(($5-$4-$8+1)%3))%3;  #remainder de cada ex 
      
      $i = $i + 1;
        }  
    }   
}

close(TOTSEXONS);
 
@dades= sort{${$a}[3] <=> ${$b}[3]}(@dades);  #funci que ens ordena la matriu 
                                                

##  transformem les columnes de la matriu dades en el vector corresponent  ##
 
$i=0;
while ($i < scalar(@dades)) {

    $codi[$i]=$dades[$i][0];    #codi
    $ppred[$i]=$dades[$i][1];   #programa prediccio de gens
    $tipus[$i]=$dades[$i][2];   #tipus exo
    $acc[$i]=$dades[$i][3];     #acceptor
    $don[$i]=$dades[$i][4];     #donor
    $pun[$i]=$dades[$i][5];     #score
    $strand[$i]=$dades[$i][6];  #strand 
    $frame[$i]=$dades[$i][7];   #frame
    $rem[$i]=$dades[$i][8];     #remainder

     $i=$i+1;
   
 }


################################2:PROGRAMA#####################################



 

my @S;   ##   vector que cont les puntuacions mximes del millor gen
my @G;   ##   vector que cont les posicions que defineixen el millor gen

my @rest= llegir_parametres($ARGV[1]); ## matriu que cont les combinacions de 
                                       ## tipus de gens imposades per l'usuari 
                                       ## i les distncies mnimes i mximes 
                                       ## entre cada parell d'exons

my @dist;  ##  vector amb les distncies existents entre dos exons consecutius



## construim tots els gens  possibles i escollim el gen de mxima puntuaci ##
## s'han de complir totes les restriccions:han de ser consecutius en el genoma
## han de tenir compatibilitat de lectura i han de complir els parmetres   ##

$i=0; 
while ($i < (scalar @acc)) {

    $S[$i]=0;
    $G[$i]=-1;

    $j = 0;
    while ($j <= $i-1) {

	$dist[$i]= $acc[$i] - $don[$j];

        if ($don[$j] < $acc[$i] && $rem[$j] == $frame[$i] && model($tipus[$j],$tipus[$i],\@rest,
            $dist[$i]) )  {

	    if ($S[$j] > $S[$i]) {

		$S[$i]=$S[$j];
		$G[$i]=$j;
	    }
	}

	$j=$j+1;
    }

    $S[$i]=$S[$i] + $pun[$i]; 
    
    $i=$i+1;
}
   


######################## 3:OBTENCI DELS RESULTATS ###########################

##  En aquest punt ja tenim  el millor gen (@G) >> aquest vector cont les  ## 
##  posicions en els vectors originals dels exons que formen el best-gene   ##
##  ara traduim aquest vector en la informaci original, volem veure quins  ##
##  sn els exons que formen el millor gen.                                 ## 
##  Per fer-ho,localitzem la posici en la que est el valor mxim de @S    ##
##  amb la funci max i extraiem el valor de cada un dels vectors originals ##
##  i @G en aquesta posici i l'enmagatzemem en els vectors definits a      ##
##  continuaci. El problema ara s, quin s el segent ex a ensamblar?La  ##
##  posici en la que estar aquest segent ex es el contingut de @G en la ##
##  posicio anterior, tal com hem fet per el primer ex, extraiem el        ##
##  contingut dels vectors inicials en aquesta nova posici i l'enmagatzamem##
##  en els nous vector. Aquest procs es repetix per tots els exons que     ##
##  formaran el millor gen.                                                 ##


my @ag;   #vector que cont els acceptors dels exons del millor gen
my @dg;   #vector que cont els donors dels exons del millor gen
my @cg;   #vector que cont la referencia de GenBank dels exons del millor gen
my @ppg;  #vector que cont el nom del programa utilitzat per predir els exons
my @tg;   #vector que el tipus de cada un dels exons del millor gen 
my @pg;   #vector que cont la puntuaci de cada ex del millor gen
my @sg;   #vector que cont l'estrand de cada ex del millor gen
my @fg;   #vector que cont el frame de cada ex del millor gen



$i = max(@S);
$j = 0;

while ($i >=0) {
   
   
   $ag[$j]=$acc[$i];
   $dg[$j]=$don[$i];  
   $cg[$j]=$codi[$i];
   $ppg[$j]=$ppred[$i];
   $tg[$j]=$tipus[$i];
   $pg[$j]=$pun[$i];
   $sg[$j]=$strand[$i];
   $fg[$j]=$frame[$i];

   $i=$G[$i];   

   $j=$j + 1;
}

## La infomaci obtinguda es en sentit 3' a 5' (ja que en l'ensamblatge hem ##
## comenat per l'ltim ex), per cal mostrar-la en sentit 5'a 3'. Per a   ##
## conseguir-ho, apliquem la funcio reverse sobre cada un dels vectors que  ##
## contenen la informaci del millor gen.                                   ##


@ag= reverse (@ag);
@dg= reverse (@dg);
@cg= reverse (@cg);
@ppg = reverse (@ppg);
@tg = reverse (@tg);
@pg = reverse (@pg);
@sg = reverse (@sg);
@fg = reverse (@fg);


print "la puntuaci del millor gen s:  ";
print maxv(@S), "\n";


## Els resultats es mostren per pantalla en format GFF al segent algorisme  ##
## iteratiu que incorpora la expressi regular necessria per poder-ho mostrar#


$i=0;

while ($i < (scalar @ag)) {

  print  "$cg[$i] \t $ppg[$i] \t $tg[$i] \t $ag[$i] \t $dg[$i] \t $pg[$i] \t $sg[$i] \t $fg[$i]\n"; 

   $i=$i + 1;
  
}










##############################################################################
########################         FUNCIONS          ###########################
##############################################################################

## Funcio per llegir els parametres (restriccions) introduts per l'usuari. ##
## Creem el filehandle PARAMETRES per poder llegir les restriccions que el  ##
## propi usuari pot determinar. Els parmetres es llegeixen en forma de     ##
## matriu, on cada columna ser un tipus de parmetre determinat.           ## 


sub llegir_parametres {
 
my $fitxerparam=$_[0];

open(PARAMETRES,"$fitxerparam") || die "el fitxer no es pot obrir";

my @restriccions;

my $i=0;

while (<PARAMETRES>) {

    if (m/(\w+)\s+(\w+)\s+(\d+)\s+(\d+)/) {

	$restriccions[$i][0]=$1;   #tipus d'ex 1 (firts/internal/terminal)
        $restriccions[$i][1]=$2;   #tipus d'ex 2
        $restriccions[$i][2]=$3;   #distncia mnima
        $restriccions[$i][3]=$4;   #distncia mxima

	$i=$i+1;
    }
}

return @restriccions;

close(PARAMETRES);
}

## Funci que accepta o no un parell d'exons segons el tipus que siguin ambdos#
## i la distncia minima i mxima que hi hagi entre ells. Compara el parell  ##
## d'exons en qesti amb les restriccions imposades per l'usuari. Si        ##
## $compleix=1 el parell d'exons es acceptat; contrariament no ho ser.      ##

sub model {

  my $prima5=$_[0];    #tipus exo j
  my $prima3=$_[1];    #tipus exo i
  my @rest = @{$_[2]}; #matriu on estan les restriccions imposades per l'usuari
  my $disminima=$_[3]; #distncia entre cada parell d'exons
  my $dismaxima=$_[3]; #distancia entra cada parell d'exons

  my $compleix=0;
  my $p=0;

  while ($p < scalar (@rest) && $compleix==0) {

    if (lc($rest[$p][0]) eq lc($prima5) && lc($rest[$p][1]) eq lc($prima3) && 
        $disminima >=$rest[$p][2] && $dismaxima <= $rest[$p][3] ) {

    $compleix=1;   
   
    }
  
  $p= $p + 1;
  
  }

  return $compleix;
}






## Aquesta funci ens diu la posici en que es troba el valor mxim d'un    ##
## vector. En el nostre cas, l'hem utilitzat per localitzar on es troba     ##
## l'ltim ex del millor gen.                                              ##

sub max {
  my $i=0;
  my $max = -99999;
  my $posmax = -1;

  while ($i < scalar(@_)) {

    if ($_[$i] >= $max) {
      $max = $_[$i];
      $posmax = $i;
      
    }

    $i = $i + 1;

  }

  return $posmax;
  
}

## Aquesta funci ens diu el valor mxim d'un vector. L'hem utilitzat per  ##
## coneixer quina es la puntuaci del millor gen.                          ##

sub maxv {
  my $i=0;
  my $max = -99999;
  my $posmax = -1;

  while ($i < scalar(@_)) {

    if ($_[$i] >= $max) {
      $max = $_[$i];
      $posmax = $i;
      
    }

    $i = $i + 1;

  }

  return $max;
  
}


 
